﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml.Serialization;

namespace tx_reporting_expensereport
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // list of resulting documents
        private List<byte[]> results = new List<byte[]>();
        private int curDocument = 1;

        private void Form1_Load(object sender, EventArgs e)
        {
            // deserialize XML into business object
            XmlSerializer serializer = new XmlSerializer(typeof(Expenses));
            Expenses expenses = (Expenses)serializer.Deserialize(new StreamReader("expense_report_data.xml"));

            // start the merge process with the business object
            // if second parameter is set to 'false', separate documents are created
            mailMerge1.MergeObjects(expenses);

            LoadResults();
        }

        // save each single document in a List
        private void mailMerge1_DataRowMerged(object sender, TXTextControl.DocumentServer.MailMerge.DataRowMergedEventArgs e)
        {
            results.Add(e.MergedRow);
        }

#region "Loading and Navigation"

        private void LoadResults()
        {
            textControl1.Tables.GridLines = false;
            textControl1.Load(results[curDocument - 1], TXTextControl.BinaryStreamType.InternalUnicodeFormat);

            toolStripLabel1.Text = curDocument.ToString() + " / " + results.Count.ToString();
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            if (curDocument != results.Count)
            {
                curDocument++;
                LoadResults();
            }
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (curDocument != 1)
            {
                curDocument--;
                LoadResults();
            }
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            curDocument = results.Count;
            LoadResults();
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            curDocument = 1;
            LoadResults();
        }

#endregion

    }
}
